summaryrefslogtreecommitdiffstats
path: root/libraries/rapidjson
diff options
context:
space:
mode:
author Andre Barboza2017-01-04 23:45:20 +0100
committer Willy Sudiarto Raharjo2017-01-07 02:48:20 +0100
commita5be379a8e6a540545b749c8189a645b66668c11 (patch)
treeaa75a9b879c18ccc0d29c9cd6a645a685ac2759e /libraries/rapidjson
parent0eacc898931c74025e9b545216ba0a68801bb727 (diff)
downloadslackbuilds-a5be379a8e6a540545b749c8189a645b66668c11.tar.gz
libraries/rapidjson: Added (a fast JSON parser/generator for C++)
Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
Diffstat (limited to 'libraries/rapidjson')
-rw-r--r--libraries/rapidjson/README23
-rw-r--r--libraries/rapidjson/rapidjson.SlackBuild94
-rw-r--r--libraries/rapidjson/rapidjson.info10
-rw-r--r--libraries/rapidjson/slack-desc19
4 files changed, 146 insertions, 0 deletions
diff --git a/libraries/rapidjson/README b/libraries/rapidjson/README
new file mode 100644
index 0000000000..e42380749c
--- /dev/null
+++ b/libraries/rapidjson/README
@@ -0,0 +1,23 @@
+RapidJSON is a JSON parser and generator for C++. It was inspired by
+RapidXml.
+
+Features:
+ - RapidJSON is small but complete. It supports both SAX and DOM
+ style API. The SAX parser is only a half thousand lines of code.
+
+ - RapidJSON is fast. Its performance can be comparable to strlen().
+ It also optionally supports SSE2/SSE4.2 for acceleration.
+
+ - RapidJSON is self-contained and header-only. It does not depend on
+ external libraries such as BOOST. It even does not depend on STL.
+
+ - RapidJSON is memory-friendly. Each JSON value occupies exactly 16
+ bytes for most 32/64-bit machines (excluding text string). By
+ default it uses a fast memory allocator, and the parser allocates
+ memory compactly during parsing.
+
+ - RapidJSON is Unicode-friendly. It supports UTF-8, UTF-16, UTF-32
+ (LE & BE), and their detection, validation and transcoding
+ internally. For example, you can read a UTF-8 file and let RapidJSON
+ transcode the JSON strings into UTF-16 in the DOM. It also supports
+ surrogates and "\u0000" (null character).
diff --git a/libraries/rapidjson/rapidjson.SlackBuild b/libraries/rapidjson/rapidjson.SlackBuild
new file mode 100644
index 0000000000..bb281e8572
--- /dev/null
+++ b/libraries/rapidjson/rapidjson.SlackBuild
@@ -0,0 +1,94 @@
+#!/bin/sh
+
+# Slackware build script for RapidJson
+
+# Copyright 2017 Andre Barboza, Belo Horizonte - Brazil
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=rapidjson
+VERSION=${VERSION:-1.1.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-v$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_INSTALL_DIR=/usr/lib${LIBDIRSUFFIX} \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+mv $PKG/usr/share/doc/RapidJSON/* $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a CHANGELOG.md license.txt readme.md readme.zh-cn.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+ln -s $PRGNAM-$VERSION $PKG/usr/doc/RapidJSON
+rmdir --parents $PKG/usr/share/doc/RapidJSON 2>/dev/null || true
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/rapidjson/rapidjson.info b/libraries/rapidjson/rapidjson.info
new file mode 100644
index 0000000000..130e20b2e4
--- /dev/null
+++ b/libraries/rapidjson/rapidjson.info
@@ -0,0 +1,10 @@
+PRGNAM="rapidjson"
+VERSION="1.1.0"
+HOMEPAGE="https://github.com/miloyip/rapidjson/"
+DOWNLOAD="https://github.com/miloyip/rapidjson/archive/v1.1.0/rapidjson-v1.1.0.tar.gz"
+MD5SUM="badd12c511e081fec6c89c43a7027bce"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Andre Barboza"
+EMAIL="bmg.andre@gmail.com"
diff --git a/libraries/rapidjson/slack-desc b/libraries/rapidjson/slack-desc
new file mode 100644
index 0000000000..98a0ed3cfe
--- /dev/null
+++ b/libraries/rapidjson/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rapidjson: rapidjson (A fast JSON parser/generator for C++)
+rapidjson:
+rapidjson: RapidJSON is a JSON parser and generator for C++. It was inspired by
+rapidjson: RapidXml. Features: SAX and DOM support, fast, self-contained and
+rapidjson: header-only. memory-friendly, Unicode-friendly.
+rapidjson:
+rapidjson:
+rapidjson:
+rapidjson:
+rapidjson: https://github.com/miloyip/rapidjson
+rapidjson: